# Class CIM_PolicyActionStructure
extends CIM_PolicyComponent

PolicyActions may be aggregated into rules and into compound actions. PolicyActionStructure is the abstract aggregation class for the structuring of policy actions.

### Table of Contents
Hierarchy
Direct Known Subclasses
Class Qualifiers
Class Properties
Class Methods

## Class Hierarchy

CIM_Component
|
+--CIM_PolicyComponent
|
+--CIM_PolicyActionStructure

## Direct Known Subclasses

CIM_PolicyActionInPolicyAction
CIM_PolicyActionInPolicyRule

## Class Qualifiers

Name | Data Type | Value
--- | --- | ---
Abstract | boolean | true
Aggregation | boolean | true
Association | boolean | true
Description | string | PolicyActions may be aggregated into rules and into compound actions. PolicyActionStructure is the abstract aggregation class for the structuring of policy actions.
UMLPackagePath | string | CIM::Policy
Version | string | 2.6.0

## Class Properties

### Local Class Properties

Name | Data Type | Default Value | Qualifiers
--- | --- | --- | ---
Name | Data Type | Value
ActionOrder | uint16 |

Description

string

ActionOrder is an unsigned integer 'n' that indicates the relative position of a PolicyAction in the sequence of actions associated with a PolicyRule or CompoundPolicyAction. When 'n' is a positive integer, it indicates a place in the sequence of actions to be performed, with smaller integers indicating earlier positions in the sequence. The special value '0' indicates 'don't care'. If two or more PolicyActions have the same non-zero sequence number, they may be performed in any order, but they must all be performed at the appropriate place in the overall action sequence. A series of examples will make ordering of PolicyActions clearer: o If all actions have the same sequence number, regardless of whether it is '0' or non-zero, any order is acceptable. o The values: 1:ACTION A 2:ACTION B 1:ACTION C 3:ACTION D indicate two acceptable orders: A,C,B,D or C,A,B,D, since A and C can be performed in either order, but only at the '1' position. o The values: 0:ACTION A 2:ACTION B 3:ACTION C 3:ACTION D require that B,C, and D occur either as B,C,D or as B,D,C. Action A may appear at any point relative to B, C, and D. Thus the complete set of acceptable orders is: A,B,C,D; B,A,C,D; B,C,A,D; B,C,D,A; A,B,D,C; B,A,D,C; B,D,A,C; B,D,C,A. Note that the non-zero sequence numbers need not start with '1', and they need not be consecutive. All that matters is their relative magnitude.

### Association References

Name | Class Origin | Reference Class
--- | --- | ---
GroupComponent | CIM_PolicyActionStructure | CIM_Policy
PartComponent | CIM_PolicyActionStructure | CIM_PolicyAction

## Class Methods